package com.sundata.internalevaluation.configuration.controller;

import com.sundata.common.base.BaseAction;
import com.sundata.internalevaluation.configuration.model.SysReqRule;
import com.sundata.internalevaluation.configuration.service.SysReqRuleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("/nprule")
public class SysReqRuleController extends BaseAction {

    @Autowired
    private SysReqRuleService sysReqRuleService;

    /**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
    @RequestMapping("list")
    public List<SysReqRule> listAll(@RequestBody SysReqRule sysReqRule) {
        return sysReqRuleService.listAll(sysReqRule);
    }


    /**
     * 根据主键查询
     *
     * @param sysReqRule 主键
     * @return 返回记录，没有返回null
     */
    @RequestMapping("getById")
    public SysReqRule getById(@RequestBody SysReqRule sysReqRule) {
//        SysReqRules rules = new SysReqRules();
//        rules.setRulesNo("rules1001");
//        rules.setRulesName("年龄判断");
//        System.out.println("****** 计算开始 *******");
//        CalcTaskResult calc = CalcUtil.calc("waterNo:" + System.currentTimeMillis(),
//                new RulesCalcUnit(rules.getRulesNo(), rules.getRulesName(), Map.of(), rules, sysReqRuleService),
//                Map.of());
//
//        System.out.println("结果："+calc);

        return sysReqRuleService.getById(sysReqRule.getRuleNo());
    }    
     
    /**
     * 新增，忽略null字段
     *
     * @param sysReqRule 新增的记录
     * @return 返回影响行数
     */
    @RequestMapping("insert")
    public int insert(@RequestBody SysReqRule sysReqRule) {
        return sysReqRuleService.insertIgnoreNull(sysReqRule);
    }    
      
    /**
     * 修改，忽略null字段
     *
     * @param sysReqRule 修改的记录
     * @return 返回影响行数
     */
    @RequestMapping("update")
    public int update(@RequestBody SysReqRule sysReqRule) {
        return sysReqRuleService.updateIgnoreNull(sysReqRule);
    }
    
    /**
     * 删除记录
     *
     * @param sysReqRule 待删除的记录
     * @return 返回影响行数
     */
    @RequestMapping("delete")
    public int delete(@RequestBody SysReqRule sysReqRule) {
        return sysReqRuleService.delete(sysReqRule);
    }
    
}