package com.sundata.internalevaluation.configuration.mapper;

import com.sundata.internalevaluation.configuration.model.DataItemConfigModel;
import com.sundata.internalevaluation.configuration.model.DataSourcesModel;
import com.sundata.internalevaluation.configuration.model.InputParamModel;
import com.sundata.internalevaluation.configuration.model.QueryLogicModel;
import io.swagger.v3.oas.annotations.Parameter;
import org.apache.ibatis.annotations.Param;


import java.util.List;

public interface DataSourcesMapper {
    List<DataSourcesModel> getDataList(DataSourcesModel model);

    List<InputParamModel> getInputParamList(String dataSourcesNo);

    List<DataItemConfigModel> getDataItemConfigList(String dataSourcesNo);

    List<QueryLogicModel> getQueryLogicList(String dataSourcesNo);

    void createData(DataSourcesModel model);

    void createInputParamData(@Param("inputParam") List<InputParamModel> inputParam);

    void createDataItemConfigData(@Param("dataItemConfig") List<DataItemConfigModel> dataItemConfig);

    void createQueryLogicData(@Param("queryLogic") List<QueryLogicModel> queryLogic);

    void deleteRows(DataSourcesModel model);

    void updateExistData(DataSourcesModel model);

    void deleteInputParamRows();

    void deleteDataSourceRows(DataSourcesModel model);

    void deleteQueryLogicRows(DataSourcesModel model);

    DataSourcesModel selectDetailData(String dataSourcesNo);
}
